diff --git a/lisp/magit/magit-sequence.el b/lisp/magit/magit-sequence.el
index 20b8146e..bfc46ebb 100644
--- a/lisp/magit/magit-sequence.el
+++ b/lisp/magit/magit-sequence.el
@@ -426,7 +426,7 @@ without prompting."
    ("-k" "Inhibit removal of email cruft"    ("-k" "--keep"))
    ("-b" "Limit removal of email cruft"      "--keep-non-patch")
    ("-d" "Use author date as committer date" "--committer-date-is-author-date")
-   ("-D" "Use committer date as author date" "--ignore-date")
+   ("-t" "Use current time as author date"   "--ignore-date")
    ("-s" "Add Signed-off-by lines"           ("-s" "--signoff"))
    (5 magit:--gpg-sign)]
   ["Apply"
@@ -514,18 +514,22 @@ This discards all changes made since the sequence started."
   ["Arguments"
    :if-not magit-rebase-in-progress-p
    ("-k" "Keep empty commits"       "--keep-empty")
-   ("-p" "Preserve merges"          ("-p" "--preserve-merges"))
+   ("-p" "Preserve merges"          ("-p" "--preserve-merges")
+    :if (lambda () (magit-git-version< "2.33.0")))
+   ("-r" "Rebase merges"            ("-r" "--rebase-merges=")
+    magit-rebase-merges-select-mode
+    :if (lambda () (magit-git-version>= "2.18.0")))
    (7 magit-merge:--strategy)
    (7 magit-merge:--strategy-option)
    (7 "=X" magit-diff:--diff-algorithm :argument "-Xdiff-algorithm=")
-   ("-d" "Lie about committer date" "--committer-date-is-author-date")
+   ("-d" "Use author date as committer date" "--committer-date-is-author-date")
+   ("-t" "Use current time as author date"   "--ignore-date")
    ("-a" "Autosquash"               "--autosquash")
    ("-A" "Autostash"                "--autostash")
    ("-i" "Interactive"              ("-i" "--interactive"))
    ("-h" "Disable hooks"            "--no-verify")
    (7 magit-rebase:--exec)
-   (5 magit:--gpg-sign)
-   (5 "-r" "Rebase merges" "--rebase-merges=" magit-rebase-merges-select-mode)]
+   (5 magit:--gpg-sign)]
   [:if-not magit-rebase-in-progress-p
    :description (lambda ()
                   (format (propertize "Rebase %s onto" 'face 'transient-heading)
@@ -852,6 +856,15 @@ edit.  With a prefix argument the old message is reused as-is."
 (defun magit--rebase-resume-command ()
   (if (file-exists-p (magit-git-dir "rebase-recursive")) "rbr" "rebase"))
 
+(defun magit-rebase--get-state-lines (file)
+  (and (magit-rebase-in-progress-p)
+       (magit-file-line
+        (magit-git-dir
+         (concat (if (file-directory-p (magit-git-dir "rebase-merge"))
+                     "rebase-merge/"
+                   "rebase-apply/")
+                 file)))))
+
 ;;; Sections
 
 (defun magit-insert-sequencer-sequence ()
diff --git a/lisp/magit/magit-sparse-checkout.el b/lisp/magit/magit-sparse-checkout.el
new file mode 100644
index 00000000..0a2c6c4e
--- /dev/null
+++ b/lisp/magit/magit-sparse-checkout.el
@@ -0,0 +1,173 @@
+;;; magit-sparse-checkout.el --- sparse checkout support for Magit  -*- lexical-binding: t -*-
+
+;; Copyright (C) 2022  The Magit Project Contributors
+;;
+;; You should have received a copy of the AUTHORS.md file which
+;; lists all contributors.  If not, see http://magit.vc/authors.
+
+;; Author: Kyle Meyer <kyle@kyleam.com>
+;; Maintainer: Jonas Bernoulli <jonas@bernoul.li>
+
+;; SPDX-License-Identifier: GPL-3.0-or-later
+
+;; Magit is free software; you can redistribute it and/or modify it
+;; under the terms of the GNU General Public License as published by
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
+;;
+;; Magit is distributed in the hope that it will be useful, but WITHOUT
+;; ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+;; or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
+;; License for more details.
+;;
+;; You should have received a copy of the GNU General Public License
+;; along with Magit.  If not, see http://www.gnu.org/licenses.
+
+;;; Commentary:
+
+;; This library provides an interface to the `git sparse-checkout'
+;; command.  It's been possible to define sparse checkouts since Git
+;; v1.7.0 by adding patterns to $GIT_DIR/info/sparse-checkout and
+;; calling `git read-tree -mu HEAD' to update the index and working
+;; tree.  However, Git v2.25 introduced the `git sparse-checkout'
+;; command along with "cone mode", which restricts the possible
+;; patterns to directories to provide better performance.
+;;
+;; The goal of this library is to support the `git sparse-checkout'
+;; command operating in cone mode.
+
+;;; Code:
+
+(require 'magit)
+
+;;; Utilities
+
+(defun magit-sparse-checkout-enabled-p ()
+  "Return non-nil if working tree is a sparse checkout."
+  (magit-get-boolean "core.sparsecheckout"))
+
+(defun magit-sparse-checkout--assert-version ()
+  ;; Older versions of Git have the ability to define sparse checkout
+  ;; patterns in .git/info/sparse-checkout, but the sparse-checkout
+  ;; command isn't available until 2.25.0.
+  (when (magit-git-version< "2.25.0")
+    (user-error "`git sparse-checkout' not available until Git v2.25")))
+
+(defun magit-sparse-checkout--auto-enable ()
+  (if (magit-sparse-checkout-enabled-p)
+      (unless (magit-get-boolean "core.sparsecheckoutcone")
+        (user-error
+         "Magit's sparse checkout functionality requires cone mode"))
+    ;; Note: Don't use `magit-sparse-checkout-enable' because it's
+    ;; asynchronous.
+    (magit-run-git "sparse-checkout" "init" "--cone")))
+
+(defun magit-sparse-checkout-directories ()
+  "Return directories that are recursively included in the sparse checkout.
+See the `git sparse-checkout' manpage for details about
+\"recursive\" versus \"parent\" directories in cone mode."
+  (and (magit-get-boolean "core.sparsecheckoutcone")
+       (mapcar #'file-name-as-directory
+               (magit-git-lines "sparse-checkout" "list"))))
+
+;;; Commands
+
+;;;###autoload (autoload 'magit-sparse-checkout "magit-sparse-checkout" nil t)
+(transient-define-prefix magit-sparse-checkout ()
+  "Create and manage sparse checkouts."
+  :man-page "git-sparse-checkout"
+  ["Arguments for enabling"
+   :if-not magit-sparse-checkout-enabled-p
+   ("-i" "Use sparse index" "--sparse-index")]
+  ["Actions"
+   [:if-not magit-sparse-checkout-enabled-p
+    ("e" "Enable sparse checkout" magit-sparse-checkout-enable)]
+   [:if magit-sparse-checkout-enabled-p
+    ("d" "Disable sparse checkout" magit-sparse-checkout-disable)
+    ("r" "Reapply rules" magit-sparse-checkout-reapply)]
+   [("s" "Set directories" magit-sparse-checkout-set)
+    ("a" "Add directories" magit-sparse-checkout-add)]])
+
+;;;###autoload
+(defun magit-sparse-checkout-enable (&optional args)
+  "Convert the working tree to a sparse checkout."
+  (interactive (list (transient-args 'magit-sparse-checkout)))
+  (magit-sparse-checkout--assert-version)
+  (magit-run-git-async "sparse-checkout" "init" "--cone" args))
+
+;;;###autoload
+(defun magit-sparse-checkout-set (directories)
+  "Restrict working tree to DIRECTORIES.
+To extend rather than override the currently configured
+directories, call `magit-sparse-checkout-add' instead."
+  (interactive
+   (list (magit-completing-read-multiple*
+          "Include these directories: "
+          ;; Note: Given that the appeal of sparse checkouts is
+          ;; dealing with very large trees, listing all subdirectories
+          ;; may need to be reconsidered.
+          (magit-revision-directories "HEAD"))))
+  (magit-sparse-checkout--assert-version)
+  (magit-sparse-checkout--auto-enable)
+  (magit-run-git-async "sparse-checkout" "set" directories))
+
+;;;###autoload
+(defun magit-sparse-checkout-add (directories)
+  "Add DIRECTORIES to the working tree.
+To override rather than extend the currently configured
+directories, call `magit-sparse-checkout-set' instead."
+  (interactive
+   (list (magit-completing-read-multiple*
+          "Add these directories: "
+          ;; Same performance note as in `magit-sparse-checkout-set',
+          ;; but even more so given the additional processing.
+          (seq-remove
+           (let ((re (concat
+                      "\\`"
+                      (regexp-opt (magit-sparse-checkout-directories)))))
+             (lambda (d) (string-match-p re d)))
+           (magit-revision-directories "HEAD")))))
+  (magit-sparse-checkout--assert-version)
+  (magit-sparse-checkout--auto-enable)
+  (magit-run-git-async "sparse-checkout" "add" directories))
+
+;;;###autoload
+(defun magit-sparse-checkout-reapply ()
+  "Reapply the sparse checkout rules to the working tree.
+Some operations such as merging or rebasing may need to check out
+files that aren't included in the sparse checkout.  Call this
+command to reset to the sparse checkout state."
+  (interactive)
+  (magit-sparse-checkout--assert-version)
+  (magit-run-git-async "sparse-checkout" "reapply"))
+
+;;;###autoload
+(defun magit-sparse-checkout-disable ()
+  "Convert sparse checkout to full checkout.
+Note that disabling the sparse checkout does not clear the
+configured directories.  Call `magit-sparse-checkout-enable' to
+restore the previous sparse checkout."
+  (interactive)
+  (magit-sparse-checkout--assert-version)
+  (magit-run-git-async "sparse-checkout" "disable"))
+
+;;; Miscellaneous
+
+(defun magit-sparse-checkout-insert-header ()
+  "Insert header line with sparse checkout information.
+This header is not inserted by default.  To enable it, add it to
+`magit-status-headers-hook'."
+  (when (magit-sparse-checkout-enabled-p)
+    (insert (propertize (format "%-10s" "Sparse! ")
+                        'font-lock-face 'magit-section-heading))
+    (insert
+     (let ((dirs (magit-sparse-checkout-directories)))
+       (pcase (length dirs)
+         (0 "top-level directory")
+         (1 (car dirs))
+         (n (format "%d directories" n)))))
+    (insert ?\n)))
+
+;;; _
+(provide 'magit-sparse-checkout)
+;;; magit-sparse-checkout.el ends here
diff --git a/lisp/magit/magit-stash.el b/lisp/magit/magit-stash.el
index 2b80fc87..7521256c 100644
--- a/lisp/magit/magit-stash.el
+++ b/lisp/magit/magit-stash.el
@@ -31,6 +31,7 @@
 
 (require 'magit)
 (require 'magit-reflog)
+(require 'magit-sequence)
 
 ;;; Options
 
@@ -95,7 +96,8 @@ AUTHOR-WIDTH has to be an integer.  When the name of the author
     ("z" "both"          magit-stash-both)
     ("i" "index"         magit-stash-index)
     ("w" "worktree"      magit-stash-worktree)
-    ("x" "keeping index" magit-stash-keep-index)]
+    ("x" "keeping index" magit-stash-keep-index)
+    ("P" "push"          magit-stash-push :level 5)]
    ["Snapshot"
     ("Z" "both"          magit-snapshot-both)
     ("I" "index"         magit-snapshot-index)
@@ -210,6 +212,30 @@ while two prefix arguments are equivalent to `--all'."
   (magit-stash-save (concat "WIP on " (magit-stash-summary))
                     index worktree untracked refresh t))
 
+;;;###autoload (autoload 'magit-stash-push "magit-stash" nil t)
+(transient-define-prefix magit-stash-push (&optional transient args)
+  "Create stash using \"git stash push\".
+
+This differs from Magit's other stashing commands, which don't
+use \"git stash\" and are generally more flexible but don't allow
+specifying a list of files to be stashed."
+  :man-page "git-stash"
+  ["Arguments"
+   (magit:-- :reader ,(-rpartial #'magit-read-files
+                                 #'magit-modified-files))
+   ("-u" "Also save untracked files" ("-u" "--include-untracked"))
+   ("-a" "Also save untracked and ignored files" ("-a" "--all"))
+   ("-k" "Keep index" ("-k" "--keep-index"))
+   ("-K" "Don't keep index" "--no-keep-index")]
+  ["Actions"
+   ("P" "push" magit-stash-push)]
+  (interactive (if (eq transient-current-command 'magit-stash-push)
+                   (list nil (transient-args 'magit-stash-push))
+                 (list t)))
+  (if transient
+      (transient-setup 'magit-stash-push)
+    (magit-run-git "stash" "push" args)))
+
 ;;;###autoload
 (defun magit-stash-apply (stash)
   "Apply a stash to the working tree.
@@ -374,14 +400,7 @@ If optional REF is non-nil, show reflog for that instead.
 If optional HEADING is non-nil, use that as section heading
 instead of \"Stashes:\"."
   (let ((verified (magit-rev-verify ref))
-        (autostash
-         (and (magit-rebase-in-progress-p)
-              (thread-first
-                  (if (file-directory-p (magit-git-dir "rebase-merge"))
-                      "rebase-merge/autostash"
-                    "rebase-apply/autostash")
-                magit-git-dir
-                magit-file-line))))
+        (autostash (magit-rebase--get-state-lines "autostash")))
     (when (or autostash verified)
       (magit-insert-section (stashes ref)
         (magit-insert-heading heading)
diff --git a/lisp/magit/magit-status.el b/lisp/magit/magit-status.el
index f4048435..eed0dcd2 100644
--- a/lisp/magit/magit-status.el
+++ b/lisp/magit/magit-status.el
@@ -340,7 +340,7 @@ init file: (global-set-key (kbd \"C-x g\") 'magit-status-quick)."
     (unless (member remote magit--remotes-using-recent-git)
       (if-let ((version (let ((default-directory directory))
                           (magit-git-version))))
-          (if (version<= magit--minimal-git version)
+          (if (magit--version>= version magit--minimal-git)
               (push remote magit--remotes-using-recent-git)
             (display-warning 'magit (format "\
 Magit requires Git >= %s, but on %s the version is %s.
diff --git a/lisp/magit/magit-submodule.el b/lisp/magit/magit-submodule.el
index f14337a2..a6d98231 100644
--- a/lisp/magit/magit-submodule.el
+++ b/lisp/magit/magit-submodule.el
@@ -225,7 +225,7 @@ it is nil, then PATH also becomes the name."
              (magit-process-sentinel process event)
            (process-put process 'inhibit-refresh t)
            (magit-process-sentinel process event)
-           (unless (version< (magit-git-version) "2.12.0")
+           (when (magit-git-version>= "2.12.0")
              (magit-call-git "submodule" "absorbgitdirs" path))
            (magit-refresh)))))))
 
@@ -360,7 +360,7 @@ to recover from making a mistake here, but don't count on it."
            (list (magit-read-module-path "Remove module")))
          (magit-submodule-arguments "--force")
          current-prefix-arg))
-  (when (version< (magit-git-version) "2.12.0")
+  (when (magit-git-version< "2.12.0")
     (error "This command requires Git v2.12.0"))
   (when magit-submodule-remove-trash-gitdirs
     (setq trash-gitdirs t))
@@ -383,14 +383,14 @@ to recover from making a mistake here, but don't count on it."
                                           (expand-file-name module))))
                   (magit-git "stash" "push"
                              "-m" "backup before removal of this module")))
-            (setq modules (cl-set-difference modules modified)))
+            (setq modules (cl-set-difference modules modified :test #'equal)))
         (if (cdr modified)
             (message "Omitting %s modules with uncommitted changes: %s"
                      (length modified)
                      (mapconcat #'identity modified ", "))
           (message "Omitting module %s, it has uncommitted changes"
                    (car modified)))
-        (setq modules (cl-set-difference modules modified))))
+        (setq modules (cl-set-difference modules modified :test #'equal))))
     (when modules
       (let ((alist
              (and trash-gitdirs
diff --git a/lisp/magit/magit-utils.el b/lisp/magit/magit-utils.el
index 75b4393c..d028dd4a 100644
--- a/lisp/magit/magit-utils.el
+++ b/lisp/magit/magit-utils.el
@@ -1010,6 +1010,16 @@ one trailing newline is added."
                 (and (eq trim ?\n) "\n"))
       str)))
 
+(defun magit--version> (v1 v2)
+  "Return t if version V1 is higher (younger) than V2.
+This function should be named `version>' and be part of Emacs."
+  (version-list-< (version-to-list v2) (version-to-list v1)))
+
+(defun magit--version>= (v1 v2)
+  "Return t if version V1 is higher (younger) than or equal to V2.
+This function should be named `version>=' and be part of Emacs."
+  (version-list-<= (version-to-list v2) (version-to-list v1)))
+
 ;;; Kludges for Emacs Bugs
 
 (defun magit-file-accessible-directory-p (filename)
@@ -1019,7 +1029,7 @@ and https://github.com/magit/magit/issues/2295."
   (and (file-directory-p filename)
        (file-accessible-directory-p filename)))
 
-(when (version<= "25.1" emacs-version)
+(when (magit--version>= emacs-version "25.1")
   (with-eval-after-load 'vc-git
     (defun vc-git-conflicted-files (directory)
       "Return the list of files with conflicts in DIRECTORY."
@@ -1158,6 +1168,9 @@ or (last of all) the value of EXP."
 (advice-add 'Info-follow-nearest-node :around
             'Info-follow-nearest-node--magit-gitman)
 
+;; When making changes here, then also adjust the copy in docs/Makefile.
+;;;###autoload
+(advice-add 'org-man-export :around 'org-man-export--magit-gitman)
 ;;;###autoload
 (defun org-man-export--magit-gitman (fn link description format)
   (if (and (eq format 'texinfo)
@@ -1177,10 +1190,6 @@ the %s(1) manpage.
 ")
     (funcall fn link description format)))
 
-;;;###autoload
-(advice-add 'org-man-export :around
-            'org-man-export--magit-gitman)
-
 ;;; Kludges for Package Managers
 
 (defun magit--straight-chase-links (filename)
@@ -1198,6 +1207,32 @@ See <https://github.com/raxod502/straight.el/issues/520>."
         (setq filename target))))
   (file-chase-links filename))
 
+;;; Kludges for older Emacs versions
+
+(if (fboundp 'with-connection-local-variables)
+    (defalias 'magit--with-connection-local-variables
+      'with-connection-local-variables)
+  (defmacro magit--with-connection-local-variables (&rest body)
+    "Abridged `with-connection-local-variables' for pre Emacs 27 compatibility.
+Bind shell file name and switch for remote execution.
+`with-connection-local-variables' isn't available until Emacs 27.
+This kludge provides the minimal functionality required by
+Magit."
+    `(if (file-remote-p default-directory)
+         (pcase-let ((`(,shell-file-name ,shell-command-switch)
+                      (with-no-warnings ; about unknown tramp functions
+                        (require 'tramp)
+                        (let ((vec (tramp-dissect-file-name
+                                    default-directory)))
+                          (list (tramp-get-method-parameter
+                                 vec 'tramp-remote-shell)
+                                (mapconcat #'identity
+                                           (tramp-get-method-parameter
+                                            vec 'tramp-remote-shell-args)
+                                           " "))))))
+           ,@body)
+       ,@body)))
+
 ;;; Miscellaneous
 
 (defun magit-message (format-string &rest args)
diff --git a/lisp/magit/magit-wip.el b/lisp/magit/magit-wip.el
index 70952a5c..7f42b573 100644
--- a/lisp/magit/magit-wip.el
+++ b/lisp/magit/magit-wip.el
@@ -304,8 +304,7 @@ commit message."
                         (and (pcase (magit-repository-local-get
                                      'update-index-has-ignore-sw-p 'unset)
                                (`unset
-                                (let ((val (version<= "2.25.0"
-                                                      (magit-git-version))))
+                                (let ((val (magit-git-version>= "2.25.0")))
                                   (magit-repository-local-set
                                    'update-index-has-ignore-sw-p val)
                                   val))
diff --git a/lisp/magit/magit.el b/lisp/magit/magit.el
index f79828d6..80a16463 100644
--- a/lisp/magit/magit.el
+++ b/lisp/magit/magit.el
@@ -447,8 +447,9 @@ is run in the top-level directory of the current working tree."
   (let ((default-directory (or directory default-directory))
         (process-environment process-environment))
     (push "GIT_PAGER=cat" process-environment)
-    (magit-start-process shell-file-name nil
-                         shell-command-switch command))
+    (magit--with-connection-local-variables
+     (magit-start-process shell-file-name nil
+                          shell-command-switch command)))
   (magit-process-buffer))
 
 (defun magit-read-shell-command (&optional toplevel initial-input)
@@ -566,7 +567,8 @@ and Emacs to it."
         (when print-dest
           (princ (format "Magit %s%s, Git %s, Emacs %s, %s"
                          (or magit-version "(unknown)")
-                         (or (and (ignore-errors (version< "2008" magit-version))
+                         (or (and (ignore-errors
+                                    (magit--version>= magit-version "2008"))
                                   (ignore-errors
                                     (require 'lisp-mnt)
                                     (and (fboundp 'lm-header)
@@ -710,6 +712,7 @@ For X11 something like ~/.xinitrc should work.\n"
     (require 'magit-subtree)
     (require 'magit-ediff)
     (require 'magit-gitignore)
+    (require 'magit-sparse-checkout)
     (require 'magit-extras)
     (require 'git-rebase)
     (require 'magit-imenu)
diff --git a/lisp/versions b/lisp/versions
index 78ac22b6..a39c856f 100644
--- a/lisp/versions
+++ b/lisp/versions
@@ -59,7 +59,8 @@
 | langtool                   | [[https://melpa.org/#/langtool][melpa]]     |           2.2.1 |    20200529.230 |                  |                 |                                                                                    |
 | ledger-mode                | [[https://melpa.org/#/ledger-mode][melpa]]     |           4.0.0 |   20211214.1449 |            4.0.0 |    20210106.227 |                                                                                    |
 | lv                         | [[https://melpa.org/#/lv][melpa]]     |               - |   20200507.1518 |                  |                 | required by hydra                                                                  |
-| magit                      | [[https://melpa.org/#/magit][melpa]]     |           3.3.0 |   20220102.1825 |            3.0.0 |   20210105.1030 | IMPORTANT do not delete and change in magit-version.el the version, see also below |
+| magit                      | [[https://melpa.org/#/magit][melpa]]     |           3.3.0 |   20220126.1645 |            3.0.0 |   20210105.1030 | IMPORTANT do not delete and change in magit-version.el the version, see also below |
+| magit-section              | [[https://melpa.org/#/magit-section][melpa]]     |           3.3.0 |    20220101.841 |                  |                 | required by magit                                                                  |
 | markdown-mode.el           | [[https://melpa.org/#/markdown-mode][melpa]]     |         2.5-dev |     20211022.55 |          2.5-dev |    20210107.101 |                                                                                    |
 | memoize.el                 | [[https://melpa.org/#/memoize][melpa]]     |             1.1 |   20200103.2036 |                  |                 | required by all-the-icons                                                          |
 | mu4e-maildirs-extension.el | [[https://melpa.org/#/mu4e-maildirs-extension][melpa]]     |             0.1 |    20201028.921 |              0.1 |    20200508.712 |                                                                                    |
@@ -173,6 +174,21 @@ du -h -s ~/repos/emacs-conf/lisp/emacs-application-framework/app/*
   version:
   git describe --tags --abbrev=0 --always \| cut -c2-
   magit-version.el template in git repo lisp/Makefile
+  #+begin_src elisp
+;;; magit-version.el --- the Magit version you are using
+
+(setq magit-version "3.3.0")
+
+(provide 'migit-version)
+
+;; Local Variables:
+;; version-control: never
+;; no-byte-compile: t
+;; no-update-autoloads: t
+;; coding: utf-8
+;; End:
+;;; magit-version.el ends here
+  #+end_src
 - yasnippet-snippets
   cd yasnippet-snippets/snippets/
   rm -r antlr-mode applescript-mode apples-mode bazel-mode chef-mode cider-repl-mode clojure-mode coq-mode cpp-omnet-mode crystal-modedart-mode dix-mode d-mode elixir-mode enh-ruby-mode ensime-mode erc-mode erlang-mode faust-mode fish-mode go-mode groovy-mode haskell-mode hy-mode java-mode julia-mode kotlin-mode lua-mode m4-mode makefile-automake-mode makefile-bsdmake-mode makefile-gmake-mode makefile-mode malabar-mode nasm-mode ned-mode nesc-mode nix-mode nsis-mode protobuf-mode racket-mode raku-mode reason-mode rjsx-mode ruby-mode rustic-mode rust-mode scala-mode swift-mode terraform-mode tuareg-mode typerex-mode typescript-mode udev-mode vhdl-mode
diff --git a/settings/version-control-settings.el b/settings/version-control-settings.el
index 3a99766e..804b9607 100644
--- a/settings/version-control-settings.el
+++ b/settings/version-control-settings.el
@@ -40,6 +40,10 @@
     (magit-section-toggle (magit-current-section)))
   (define-key magit-mode-map [left-fringe mouse-1] 'my-magit-fringe-click))
 
+(use-package magit-section
+  :load-path (lambda() (concat config-dir "lisp/magit-section"))
+  :defer t)
+
 ;; On Windows, we must use Git GUI to enter username and password
 ;; See: https://github.com/magit/magit/wiki/FAQ#windows-cannot-push-via-https
 (when (eq window-system 'w32)
